//
//  BridgeManager.swift
//  react-native-trackflow
//
//  Created by Anooj Krishnan G on 06/10/20.
//

import Foundation
import Trackflow

class BridgeManager: NSObject{
    
    var apiKey:String?
    static let shared = BridgeManager();
    
    override init() {
        super.init()
    }
    
    func start(apiKey:String){
                     TFConstants.isAPILogEnabled = true
                    //TFConstants.isShakeDeviceEnabled = true
                     TFConstants.isAutomaticScreenshotEnabled = true  
                    TFConstants.isPermissionsEnabled = true
                    TFConstants.isScreenShotReqEnabled = true
                    TFConstants.isAsyncStorageReq = true
                     TFConstants.isDeviceInfoReq = true
                   // TFShakeListener.shared.start();

        self.apiKey = apiKey;
        let params = TFManager.shared.getQueryDict(apiKey: apiKey);
        Transporter.shared.connect(url: TFConstants.TRACKFLOW_ENDPOINT, params: params);

    }

   func startTrackingWithOptions(apiKey:String, with:[String]){
          if(with.count > 0){

            for option in with.enumerated(){
                if(option.element == TFTrackingOptions.NETWORKLOGS){
                    TFConstants.isAPILogEnabled = true
                }else if(option.element == TFTrackingOptions.SHAKE){
                     TFShakeListener.shared.start();
                    //TFConstants.isShakeDeviceEnabled = true
                }
                else if(option.element == TFTrackingOptions.AUTO_CAPTURE){
                    TFConstants.isAutomaticScreenshotEnabled = true  
                }else if(option.element == TFTrackingOptions.PERMISSIONS){
                    TFConstants.isPermissionsEnabled = true
                }else if(option.element == TFTrackingOptions.SCREENSHOT_WEB_REQUEST){
                    TFConstants.isScreenShotReqEnabled = true
                }
                else if(option.element == TFTrackingOptions.ASYNCSTORAGE){
                    TFConstants.isAsyncStorageReq = true
                }
                else if(option.element == TFTrackingOptions.DEVICEINFO){
                    TFConstants.isDeviceInfoReq = true
                }
               
            }
        }
        self.apiKey = apiKey;
        let params = TFManager.shared.getQueryDict(apiKey: apiKey);
        Transporter.shared.connect(url: TFConstants.TRACKFLOW_ENDPOINT, params: params);
    }
    
    func captureScreenshotWithScreenName(screenName:String){
        Transporter.shared.autoCapturedImageData(screenName: screenName)
    }

    func sendTrackflowLogs(log:String){
        Transporter.shared.sendLog(log: log)
    }
    
    public func sendNetworkLog(log:String){
            Transporter.shared.sendNetworkLog(log: log);
        }

       public  func logAsyncStorage(asyncstorge:String){
            Transporter.shared.sendAsyncStorage(log: asyncstorge);
        }

        public func getDetails(){

          TFDeviceManager.shared.getWiFiSsid()
          TFDeviceManager.shared.getIPAddress()
          TFDeviceManager.shared.batteryStatus()
          TFDeviceManager.shared.getInterfaces()
          TFDeviceManager.shared.getLocation()

        }

        public func getTrackflowVersion() -> String{
           return "1.0";
       }

        public func isConnected() -> Bool{
            return Transporter.shared.isConnected();
        }

        public func captureScreenshot() -> String {            
            return ""
        }

        public func getPermission(){

        }

        public func initDeviceInfo() -> NSMutableDictionary{
            return TFManager.shared.initDeviceInfo();
        }


        public func getInitInfo() -> NSMutableDictionary{
            return TFManager.shared.getInitInfo();
        }
        
        public func getDeviceInfo() -> NSMutableDictionary{
            return TFManager.shared.getDeviceInfo();
        }
}
