//
//  Trackflow.swift
//  Trackflow
//
//  Created by Anooj Krishnan G on 29/08/20.
//  Copyright © 2020 Synclovis Systems Pvt Ltd. All rights reserved.
//


import Foundation
import Trackflow

@objc(Trackflow)
class Trackflow: RCTEventEmitter {

    override init() {
        super.init()
        EventEmitter.sharedInstance.registerEventEmitter(eventEmitter: self)
    }
   
    @objc func startTracking(_ apiKey: String) -> Void{
        print("-----------TRACKFLOW-------------")

        let bManager:BridgeManager = BridgeManager.shared;
        bManager.start(apiKey: apiKey)
    }
    
    @objc func startTrackingServices(_ apiKey: String ,  options:[String]) -> Void{
                print("-----------TRACKFLOWSERVICES-------------")
        
         let bManager:BridgeManager = BridgeManager.shared;
        bManager.startTrackingWithOptions(apiKey: apiKey, with: options)
    }
    
    @objc func analyse(_ screenName:String) -> Void{

        let bManager:BridgeManager = BridgeManager.shared;
        bManager.captureScreenshotWithScreenName(screenName:screenName )
    }

    @objc func log(_ log:String) -> Void{

        let bManager:BridgeManager = BridgeManager.shared;
        bManager.sendTrackflowLogs(log:log)
    }
    
    @objc func logAsyncStorage(_ log: String) -> Void{
        BridgeManager.shared.logAsyncStorage(asyncstorge: log);
    }
    
    @objc func logNetwork(_ log: String) -> Void{
        //Start network log        
        BridgeManager.shared.sendNetworkLog(log: log)
    }
    
    @objc func logStackTrace(_ log: String) -> Void{
        
        
    }
    @objc func getDeviceInfo(_ resolve: @escaping RCTPromiseResolveBlock, rejecter reject: RCTPromiseRejectBlock) -> Void {
        let jsonObject: NSMutableDictionary = TFManager.shared.getDeviceInfo();
        let jsonData: NSData
        var jsonString:String = "{}";

        do {
            jsonData = try JSONSerialization.data(withJSONObject: jsonObject, options: JSONSerialization.WritingOptions()) as NSData
            let jsonString = NSString(data: jsonData as Data, encoding: String.Encoding.utf8.rawValue) as! String            
             resolve(jsonString);

        } catch _ {
            print ("JSON Failure")
             resolve(jsonString);
        }
    }

    @objc func getLocation(_ key:String){
        TFDeviceManager.shared.getLocation();
    }


    override func supportedEvents() -> [String]! {
        return EventEmitter.sharedInstance.allEvents
    }

     override func constantsToExport() -> [AnyHashable : Any]! {
        return [
            "SHAKE":TFTrackingOptions.SHAKE,
            "AUTO_CAPTURE":TFTrackingOptions.AUTO_CAPTURE,
            "SCREENSHOT_WEB_REQUEST":TFTrackingOptions.SCREENSHOT_WEB_REQUEST,
            "PERMISSIONS":TFTrackingOptions.PERMISSIONS,
             "ASYNCSTORAGE" :TFTrackingOptions.ASYNCSTORAGE,
             "DEVICEINFO" :TFTrackingOptions.DEVICEINFO,
             "NETWORKLOGS" :TFTrackingOptions.NETWORKLOGS
            
        ]
    }

    override class func requiresMainQueueSetup() -> Bool {
        return true;
    }

    @objc func version (_ resolve: @escaping RCTPromiseResolveBlock, rejecter reject: RCTPromiseRejectBlock) -> Void {
        resolve("1.0");
    }
    
    func getAsyncStorage(){
        self.triggerEvent(eventName: "async_storage", data: "fetch")
    }
    
    func triggerEvent( eventName: String , data: String) {
        
    }
}
    

