/*
*   © Trackflow.ai
*   React Native SDK
*
*   This file shows the sample code to use our User Journey (aka Auto Capture) feature.
*   If you are using React-Navigation, you need to add the following code snippet to activate the feature.
*/

//(Add this code to root navigator)

/*
*  Code snippet for projects using redux and single navigation function
*/

/*

// -------- START  -------- //

function getCurrentRouteName(navigationState) {
  if (!navigationState) {
    return null;
  }
  const route = navigationState.routes[navigationState.index];

  if (route.routes) {
    return getCurrentRouteName(route);
  }
  return route.routeName;
}

<AppContainer
  onNavigationStateChange={(prevState, currentState) => {
    const prevScreen = getCurrentRouteName(prevState);
    const currentScreen = getCurrentRouteName(currentState);

    if (currentScreen !== prevScreen) {
      setTimeout(
        function () {
          Trackflow.analyse(currentScreen);
        }.bind(this),
        2000
      );
    }
  }}
/>;

// -------- END  -------- //

*/


/*
*   Code snippet for the projects with redux & separate navigations
*/

/*

// -------- START  -------- //

import { useRef } from "react";

const navigationRef = useRef();
const routeNameRef = useRef();

<NavigationContainer ref={navigationRef} onStateChange={getScreenNameNavigate}>
  <App />
</NavigationContainer>;

async function getScreenNameNavigate() {
  const previousRouteName = routeNameRef.current;
  const currentRouteName = navigationRef.current.getCurrentRoute().name;

  if (previousRouteName !== currentRouteName) {    
    setTimeout(
      function () {
         Trackflow.analyse(currentRouteName)
      }.bind(this),
      2000
    );
  }  
  routeNameRef.current = currentRouteName;
}

// -------- END  -------- //

*/
