/*
*   © Trackflow.ai
*   React Native SDK
*
*   This file shows the sample code to use our User Journey (aka Auto Capture) feature.
*   If you are using React-Native-Router-Flux (RNRF), you need to add the following code snippet to activate the feature.
*/

/*
*   Integration can be done in two ways.
*   1. Using reducer in Router component
*   2. Using onStateChange in Router component
*/

// Integration 1 - Using reducer in Router component
 
/* 
// -------- START  -------- //

// Create a constant reducerCreate.

const reducerCreate = (params) => {
  const defaultReducer = new Reducer(params);
  return (state, action) => {
    if (action.type == "REACT_NATIVE_ROUTER_FLUX_FOCUS") {
      setTimeout(
        function () {
          Trackflow.analyse(action.routeName);
        }.bind(this),
        2000
      );
    }
    return defaultReducer(state, action);
  };
};

// Assign reducerCreate createReducer prop of Router component.

<Router
	...
	createReducer={reducerCreate}
	...
/>

// -------- END  -------- //

*/

// Integration 2 - Using onStateChange in Router component

/* 
// -------- START  -------- //
    
<Router                    
    onStateChange={stateHandler}
/>

const stateHandler = (prevState, newState, action) => {
    navigationActon = action;
    if (action.type == "Navigation/PUSH" || action.type == "Navigation/JUMP_TO") {
      setTimeout(
        function () {
          Trackflow.analyse("From PUSH" + action.routeName);
        }.bind(this),
        2000
      );
    } else {
      if (action.type == "Navigation/RESET") {
        setTimeout(
          function () {
            Trackflow.analyse("from RESET" + action.actions[0].routeName);
          }.bind(this),
          2000
        );
        action.actions.map((vaule) => {});
      }
    }
  };

// -------- END  -------- //

*/
                 